Tagebuch – Tag 3: Docker Compose & Portainer





Kurze Beschreibung von Docker Compose:


Docker Compose ist ein Tool zur Verwaltung mehrerer Docker-Container mit einer einzigen YAML-Datei. Es erleichtert das Starten, Stoppen und Konfigurieren von Anwendungen, die aus mehreren Services bestehen, indem alle Abhängigkeiten und Netzwerke automatisch verwaltet werden.

Docker Compose – Version 2 der App starten
Schritte zum Starten der Version 2 der To-Do-App mit Docker Compose
Erstellen der docker-compose.yaml Datei:

yaml
Kopieren
Bearbeiten
version: "3"

services:
  todoapp:
    build: ./web-frontend
    ports:
      - "3000:3000"
    depends_on:
      - redis-master
      - redis-slave
    networks:
      - todoapp_network

  redis-slave:
    build: ./redis-slave
    depends_on:
      - redis-master
    networks:
      - todoapp_network

  redis-master:
    build: ./redis-master
    networks:
      - todoapp_network

networks:
  todoapp_network:
    name: todoapp_network
    driver: bridge
Befehle zum Starten der Anwendung:

bash
Kopieren
Bearbeiten
docker-compose -f docker-compose.yaml up -d
Prüfen, ob alle Container laufen:

bash
Kopieren
Bearbeiten
docker ps
Logs eines Containers ansehen:

bash
Kopieren
Bearbeiten
docker logs -f <container_id>
System stoppen und aufräumen:

bash
Kopieren
Bearbeiten
docker-compose -f docker-compose.yaml down
docker system prune -a --volumes
PrintScreens wurden aufgenommen und ins Portfolio eingefügt.

Portainer Installation und Nutzung
Installation von Portainer mit Docker Compose
Erstellen der docker-compose.yaml Datei für Portainer:

yaml
Kopieren
Bearbeiten
version: '3'

services:
  portainer:
    image: portainer/portainer-ce:latest
    container_name: portainer
    restart: unless-stopped
    security_opt:
      - no-new-privileges:true
    volumes:
      - /etc/localtime:/etc/localtime:ro
      - /var/run/docker.sock:/var/run/docker.sock:ro
      - ./portainer-data:/data
    ports:
      - 9000:9000
Starten von Portainer:

bash
Kopieren
Bearbeiten
docker-compose -f docker-compose.yaml up -d
Zugriff auf Portainer über den Browser:

cpp
Kopieren
Bearbeiten
http://<VM-IP>:9000
Registrierung abgeschlossen und erste Tests durchgeführt.

Die To-Do-App wurde erfolgreich über Portainer hinzugefügt und gestartet.
PrintScreens wurden aufgenommen und ins Portfolio eingefügt.







***Docker Compose***

`version: "3"

services:

  todoapp:

    build: ./web-frontendv2

    ports:

     - "3000"

     

    depends_on:

     - redis-master

     - redis-slave

    networks:

     - todoapp_network

  redis-slave:

    build: ./redis-slave

    depends_on:

     - redis-master

    networks:

     - todoapp_network

  redis-master:

    build: ./redis-master

    networks:

     - todoapp_network

networks:

  todoapp_network:

    name: todoapp_network

    driver: bridge`







![alt text](image.png)
![alt text](image-1.png)