# Kubernetes und Microservices

## Was ist Kubernetes?
Kubernetes ist ein Open-Source-Orchestrierungstool für **Cloud-native Microservice-Anwendungen**. Es bietet eine leistungsstarke Plattform zur Automatisierung von:

- **Skalierung** von Anwendungen
- **Self-Healing** zur Wiederherstellung fehlerhafter Dienste
- **Automatischen Updates** für kontinuierliche Verbesserung

Kubernetes wird von der **Cloud Native Computing Foundation (CNCF)** verwaltet und ist ein zentraler Bestandteil moderner, verteilter Systeme.

---

## Was sind Microservices?
**Microservices** sind ein Architekturansatz, bei dem eine Anwendung in **kleine, unabhängige Dienste** unterteilt wird. Jeder Dienst hat eine spezifische Aufgabe und kommuniziert mit anderen über **APIs**.

### Vorteile von Microservices:
✅ **Skalierbarkeit** – Jeder Dienst kann individuell skaliert werden.
✅ **Flexibilität** – Einfachere Weiterentwicklung und Bereitstellung neuer Features.
✅ **Bessere Wartbarkeit** – Modularer Code erleichtert Updates und Debugging.

Kubernetes erleichtert die Bereitstellung und Verwaltung von Microservices erheblich. Durch die **Entkopplung der Dienste** können Unternehmen Innovationen schneller umsetzen.

---

## Vergleich: Lightweight Kubernetes-Tools
Für lokale Entwicklung und ressourcenschonende Kubernetes-Cluster gibt es verschiedene Tools:

| Tool            | Beschreibung |
|----------------|-------------|
| **minikube**   | Einfache, Single-Node-K8s-Umgebung für Tests. |
| **microk8s**   | Kleinste, schnellste und CNCF-konforme K8s-Distribution für Ubuntu. |
| **kubeadm**    | Ermöglicht Einrichtung von Single-Node bis High-Availability (HA) Clustern. |
| **Docker for Windows** | Integriertes Kubernetes in Docker Desktop. |
| **kind**       | Erstellt K8s-Cluster mit Docker-Containern. |
| **k3s**        | Extrem leichtgewichtig, optimiert für IoT und Edge-Computing. |

Diese Tools bieten verschiedene Einsatzmöglichkeiten – von einfacher **lokaler Entwicklung** bis hin zu **ressourcenschonenden Kubernetes-Deployments** für spezielle Anwendungen.

---

## Anleitung: Kubernetes in Docker aktivieren
Um Kubernetes in Docker Desktop zu aktivieren, folge diesen Schritten:

1. **Docker öffnen**
2. **Einstellungen von Docker öffnen**
3. **Auf "Kubernetes" navigieren**
4. **"Enable Kubernetes" aktivieren**

Nachdem du diese Schritte ausgeführt hast, wird Kubernetes in Docker gestartet und kann verwendet werden.








![alt text](image-1.png)