# Raft-Konsens-Algorithmus

Der **Raft-Konsens-Algorithmus** sorgt dafür, dass mehrere Server in einem verteilten System eine einheitliche Entscheidung über den Zustand der Daten treffen. Er stellt sicher, dass alle Server im Cluster synchron bleiben, selbst wenn einige ausfallen.

## Funktionsweise

1. Einer der Server wird zum **Leader** gewählt.  
2. Die anderen Server sind **Follower** und übernehmen Änderungen nur vom Leader.  
3. Fällt der Leader aus, wird ein neuer durch Abstimmung gewählt.  

## Warum eine ungerade Anzahl von Servern?

Raft trifft Entscheidungen per **Mehrheitsprinzip**. Eine **ungerade Anzahl von Servern** verhindert **Patt-Situationen**, da es immer eine klare **Mehrheit** gibt.  

Typische Cluster-Größen sind **3, 5 oder 7 Server**, um eine stabile Entscheidungsfindung zu gewährleisten.



# Wichtige Konzepte in verteilten Systemen

## Self Healing  
Ein System erkennt Fehler automatisch und behebt sie selbstständig, z. B. durch Neustart fehlerhafter Komponenten oder Umverteilung von Lasten.  

## Scale Up  
Erhöhung der Leistung durch **stärkere Hardware** (z. B. mehr CPU/RAM auf einem Server).  

## Scale Down  
Reduzierung der Ressourcen, wenn weniger Leistung benötigt wird, um Kosten zu sparen (z. B. Abschalten ungenutzter Instanzen).  




# Blue-Green Deployment  

Ein **Blue-Green Deployment** ist eine Strategie zur **risikofreien Bereitstellung** neuer Software-Versionen.  

## Ablauf  
1. **Blue** (alte Version) läuft live.  
2. **Green** (neue Version) wird parallel bereitgestellt.  
3. Nach Tests wird der Traffic von **Blue** auf **Green** umgeschaltet.  
4. Falls Probleme auftreten, kann schnell auf **Blue** zurückgewechselt werden.  

✅ **Vorteile:** Kein Downtime, schnelles Rollback, sicheres Deployment.  






![alt text](image.png)




![alt text](image-1.png)