Tag 7


## Cluster IP und Node IP

### **Cluster IP**
- Eine **Cluster IP** ist die interne IP-Adresse eines Kubernetes-Dienstes innerhalb des Clusters.
- Wird automatisch von Kubernetes zugewiesen und ist nur innerhalb des Clusters erreichbar.
- Verwendet, um die Kommunikation zwischen Pods über den Kubernetes-Dienst zu ermöglichen.
- Beispiel für das Abrufen einer Cluster IP:
  ```sh
  kubectl get svc <service-name> -o wide
  ```

### **Node IP**
- Eine **Node IP** ist die IP-Adresse des Kubernetes-Worker-Knotens.
- Diese wird von der Infrastruktur oder Cloud-Anbieter zugewiesen.
- Nützlich, um direkt mit Pods zu kommunizieren, wenn **NodePort** oder **HostNetwork** verwendet wird.
- Beispiel für das Abrufen einer Node IP:
  ```sh
  kubectl get nodes -o wide
  ```

## LoadBalancer

- Ein **LoadBalancer**-Dienst in Kubernetes wird verwendet, um externen Traffic zu verteilen.
- Funktioniert mit Cloud-Providern (z. B. AWS, GCP, Azure) zur Bereitstellung eines extern erreichbaren Load Balancers.
- Wird über `kubectl expose` oder `kubectl apply -f` mit `type: LoadBalancer` erstellt.
- Überprüfung des LoadBalancer-Status:
  ```sh
  kubectl get svc my-loadbalancer
  



## Erklärung zu 404:

Der Ingress ist für die Domain my-app.com konfiguriert. Wird stattdessen 127.0.0.1 (localhost) aufgerufen, stimmt der Hostname nicht mit der Ingress-Regel überein. Dadurch findet der Ingress keine passende Route, was zu einem 404-Fehler führt.

Der Ingress-Controller überprüft bei jeder Anfrage den Host-Header, um zu bestimmen, welchem Service sie zugeordnet wird. Da eine Anfrage an 127.0.0.1 keinen Host-Header mit my-app.com enthält, kann der Ingress die Anfrage keinem passenden Backend-Service zuweisen.


![alt text](image.png)
![alt text](image-1.png)